/***********************************************
 *
 * Angelscript Dumper v2.1 by learn_more
 * File: out\a179\script\cam_dump.as
 * Generated: 21-May-2012 19:02:25
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b5c20 (0x7b5c20)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xbeba0 (0x4beba0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xbebd0 (0x4bebd0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b60a0 (0x7b60a0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b67e0 (0x7b67e0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b6570 (0x7b6570)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b6460 (0x7b6460)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b6840 (0x7b6840)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b6330 (0x7b6330)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b6050 (0x7b6050)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b6810 (0x7b6810)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b60d0 (0x7b60d0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b6200 (0x7b6200)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b5c70 (0x7b5c70)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b5770 (0x7b5770)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24deb0 (0x64deb0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24cd00 (0x64cd00)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24cd60 (0x64cd60)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24dcc0 (0x64dcc0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24dd30 (0x64dd30)
	void Update();		// 'Overgrowth.exe' + 0x251a80 (0x651a80)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2ac3f0 (0x6ac3f0)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2ac3a0 (0x6ac3a0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37c950 (0x77c950)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37c7b0 (0x77c7b0)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x37c770 (0x77c770)
	float GetLens();		// 'Overgrowth.exe' + 0x37c790 (0x77c790)
	void Update();		// 'Overgrowth.exe' + 0x37b930 (0x77b930)
	bool valid();		// 'Overgrowth.exe' + 0x37acf0 (0x77acf0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;
SphereCollision sphere_col;
GUI gui;
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x433970 (0x833970)
CameraObject co;
CameraAnimationReader camera_animation_reader;
